javax.enterprise.deploy.spi

## Interface DeploymentManager

-     public interface DeploymentManager

  The DeploymentManager object provides the core set of functions a Java EE platform must provide for Java EE application deployment. It provides server related information, such as, a list of deployment targets, and vendor unique runtime configuration information.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `DeploymentConfiguration` | `createConfiguration(DeployableObject dObj)` Retrieve the object that provides server-specific deployment configuration information for the Java EE deployable component.
    `ProgressObject` | `distribute(Target[] targetList, File moduleArchive, File deploymentPlan)` The distribute method performs three tasks; it validates the deployment configuration data, generates all container specific classes and interfaces, and moves the fully baked archive to the designated deployment targets.
    `ProgressObject` | `distribute(Target[] targetList, InputStream moduleArchive, InputStream deploymentPlan)` Deprecated. as of Java EE 5, replaced with `distribute(Target[], ModuleType, InputStream, InputStream)`
    `ProgressObject` | `distribute(Target[] targetList, ModuleType type, InputStream moduleArchive, InputStream deploymentPlan)` The distribute method performs three tasks; it validates the deployment configuration data, generates all container specific classes and interfaces, and moves the fully baked archive to the designated deployment targets.
    `TargetModuleID[]` | `getAvailableModules(ModuleType moduleType, Target[] targetList)` Retrieve the list of all Java EE application modules running or not running on the identified targets.
    `Locale` | `getCurrentLocale()` Returns the active locale this implementation of javax.enterprise.deploy.spi subpackages is running.
    `DConfigBeanVersionType` | `getDConfigBeanVersion()` Returns the Java EE platform version number for which the configuration beans are provided.
    `Locale` | `getDefaultLocale()` Returns the default locale supported by this implementation of javax.enterprise.deploy.spi subpackages.
    `TargetModuleID[]` | `getNonRunningModules(ModuleType moduleType, Target[] targetList)` Retrieve the list of Java EE application modules distributed to the identified targets and that are currently not running on the associated server or servers.
    `TargetModuleID[]` | `getRunningModules(ModuleType moduleType, Target[] targetList)` Retrieve the list of Java EE application modules distributed to the identified targets and that are currently running on the associated server or servers.
    `Locale[]` | `getSupportedLocales()` Returns an array of supported locales for this implementation.
    `Target[]` | `getTargets()` Retrieve the list of deployment targets supported by this DeploymentManager.
    `boolean` | `isDConfigBeanVersionSupported(DConfigBeanVersionType version)` Returns 'true' if the configuration beans support the Java EE platform version specified.
    `boolean` | `isLocaleSupported(Locale locale)` Reports if this implementation supports the designated locale.
    `boolean` | `isRedeploySupported()` This method designates whether this platform vendor provides application redeployment functionality.
    `ProgressObject` | `redeploy(TargetModuleID[] moduleIDList, File moduleArchive, File deploymentPlan)` (optional) The redeploy method provides a means for updating currently deployed Java EE applications.
    `ProgressObject` | `redeploy(TargetModuleID[] moduleIDList, InputStream moduleArchive, InputStream deploymentPlan)` (optional) The redeploy method provides a means for updating currently deployed Java EE applications.
    `void` | `release()` The release method is the mechanism by which the tool signals to the DeploymentManager that the tool does not need it to continue running connected to the platform.
    `void` | `setDConfigBeanVersion(DConfigBeanVersionType version)` Set the configuration beans to be used to the Java EE platform version specificed.
    `void` | `setLocale(Locale locale)` Set the active locale for this implementation of javax.enterprise.deploy.spi subpackages to run.
    `ProgressObject` | `start(TargetModuleID[] moduleIDList)` Start the application running.
    `ProgressObject` | `stop(TargetModuleID[] moduleIDList)` Stop the application running.
    `ProgressObject` | `undeploy(TargetModuleID[] moduleIDList)` Remove the application from the target server.

- - ### Method Detail

    - #### getTargets

          Target[] getTargets()
                              throws IllegalStateException

      Retrieve the list of deployment targets supported by this DeploymentManager.
      Returns:
        A list of deployment Target designators the user may select for application deployment or 'null' if there are none.
      Throws:
        `IllegalStateException` - is thrown when the method is called when running in disconnected mode.

    - #### getRunningModules

          TargetModuleID[] getRunningModules(ModuleType moduleType,
                                           Target[] targetList)
                                             throws TargetException,
                                                    IllegalStateException

      Retrieve the list of Java EE application modules distributed to the identified targets and that are currently running on the associated server or servers.
      Parameters:
        `moduleType` - A predefined designator for a Java EE module type.
        `targetList` - A list of deployment Target designators the user wants checked for module run status.
      Returns:
        An array of TargetModuleID objects representing the running modules or 'null' if there are none.
      Throws:
        `IllegalStateException` - is thrown when the method is called when running in disconnected mode.
        `TargetException` - An invalid Target designator encountered.

    - #### getNonRunningModules

          TargetModuleID[] getNonRunningModules(ModuleType moduleType,
                                              Target[] targetList)
                                                throws TargetException,
                                                       IllegalStateException

      Retrieve the list of Java EE application modules distributed to the identified targets and that are currently not running on the associated server or servers.
      Parameters:
        `moduleType` - A predefined designator for a Java EE module type.
        `targetList` - A list of deployment Target designators the user wants checked for module not running status.
      Returns:
        An array of TargetModuleID objects representing the non-running modules or 'null' if there are none.
      Throws:
        `IllegalStateException` - is thrown when the method is called when running in disconnected mode.
        `TargetException` - An invalid Target designator encountered.

    - #### getAvailableModules

          TargetModuleID[] getAvailableModules(ModuleType moduleType,
                                             Target[] targetList)
                                               throws TargetException,
                                                      IllegalStateException

      Retrieve the list of all Java EE application modules running or not running on the identified targets.
      Parameters:
        `moduleType` - A predefined designator for a Java EE module type.
        `targetList` - A list of deployment Target designators the user wants checked for module not running status.
      Returns:
        An array of TargetModuleID objects representing all deployed modules running or not or 'null' if there are no deployed modules.
      Throws:
        `IllegalStateException` - is thrown when the method is called when running in disconnected mode.
        `TargetException` - An invalid Target designator encountered.

    - #### createConfiguration

          DeploymentConfiguration createConfiguration(DeployableObject dObj)
                                                      throws InvalidModuleException

      Retrieve the object that provides server-specific deployment configuration information for the Java EE deployable component.
      Parameters:
        `dObj` - An object representing a Java EE deployable component.
      Throws:
        `InvalidModuleException` - The DeployableObject is an unknown or unsupport component for this configuration tool.

    - #### distribute

          ProgressObject distribute(Target[] targetList,
                                  File moduleArchive,
                                  File deploymentPlan)
                                    throws IllegalStateException

      The distribute method performs three tasks; it validates the deployment configuration data, generates all container specific classes and interfaces, and moves the fully baked archive to the designated deployment targets.
      Parameters:
        `targetList` - A list of server targets the user is specifying this application be deployed to.
        `moduleArchive` - The file name of the application archive to be disrtibuted.
        `deploymentPlan` - The XML file containing the runtime configuration information associated with this application archive.
      Returns:
        ProgressObject an object that tracks and reports the status of the distribution process.
      Throws:
        `IllegalStateException` - is thrown when the method is called when running in disconnected mode.

    - #### distribute

          ProgressObject distribute(Target[] targetList,
                                  InputStream moduleArchive,
                                  InputStream deploymentPlan)
                                    throws IllegalStateException

      Deprecated. as of Java EE 5, replaced with `distribute(Target[], ModuleType, InputStream, InputStream)`
      The distribute method performs three tasks; it validates the deployment configuration data, generates all container specific classes and interfaces, and moves the fully baked archive to the designated deployment targets.
      Parameters:
        `targetList` - A list of server targets the user is specifying this application be deployed to.
        `moduleArchive` - The input stream containing the application archive to be disrtibuted.
        `deploymentPlan` - The input stream containing the deployment configuration information associated with this application archive.
      Returns:
        ProgressObject an object that tracks and reports the status of the distribution process.
      Throws:
        `IllegalStateException` - is thrown when the method is called when running in disconnected mode.

    - #### distribute

          ProgressObject distribute(Target[] targetList,
                                  ModuleType type,
                                  InputStream moduleArchive,
                                  InputStream deploymentPlan)
                                    throws IllegalStateException

      The distribute method performs three tasks; it validates the deployment configuration data, generates all container specific classes and interfaces, and moves the fully baked archive to the designated deployment targets.
      Parameters:
        `targetList` - A list of server targets the user is specifying this application be deployed to.
        `moduleType` - The module type of this application archive.
        `moduleArchive` - The input stream containing the application archive to be disrtibuted.
        `deploymentPlan` - The input stream containing the deployment configuration information associated with this application archive.
      Returns:
        ProgressObject an object that tracks and reports the status of the distribution process.
      Throws:
        `IllegalStateException` - is thrown when the method is called when running in disconnected mode.

    - #### start

          ProgressObject start(TargetModuleID[] moduleIDList)
                               throws IllegalStateException

      Start the application running.

      Only the TargetModuleIDs which represent a root module are valid for being started. A root TargetModuleID has no parent. A TargetModuleID with a parent can not be individually started. A root TargetModuleID module and all its child modules will be started.

      Parameters:
        `moduleIDList` - A array of TargetModuleID objects representing the modules to be started.
      Returns:
        ProgressObject an object that tracks and reports the status of the start operation.
      Throws:
        `IllegalStateException` - is thrown when the method is called when running in disconnected mode.

    - #### stop

          ProgressObject stop(TargetModuleID[] moduleIDList)
                              throws IllegalStateException

      Stop the application running.

      Only the TargetModuleIDs which represent a root module are valid for being stopped. A root TargetModuleID has no parent. A TargetModuleID with a parent can not be individually stopped. A root TargetModuleID module and all its child modules will be stopped.

      Parameters:
        `moduleIDList` - A array of TargetModuleID objects representing the modules to be stopped.
      Returns:
        ProgressObject an object that tracks and reports the status of the stop operation.
      Throws:
        `IllegalStateException` - is thrown when the method is called when running in disconnected mode.

    - #### undeploy

          ProgressObject undeploy(TargetModuleID[] moduleIDList)
                                  throws IllegalStateException

      Remove the application from the target server.

      Only the TargetModuleIDs which represent a root module are valid for undeployment. A root TargetModuleID has no parent. A TargetModuleID with a parent can not be undeployed. A root TargetModuleID module and all its child modules will be undeployed. The root TargetModuleID module and all its child modules must stopped before they can be undeployed.

      Parameters:
        `moduleIDList` - An array of TargetModuleID objects representing the root modules to be stopped.
      Returns:
        ProgressObject an object that tracks and reports the status of the stop operation.
      Throws:
        `IllegalStateException` - is thrown when the method is called when running in disconnected mode.

    - #### isRedeploySupported

          boolean isRedeploySupported()

      This method designates whether this platform vendor provides application redeployment functionality. A value of true means it is supported. False means it is not.
      Returns:
        A value of true means redeployment is supported by this vendor's DeploymentManager. False means it is not.

    - #### redeploy

          ProgressObject redeploy(TargetModuleID[] moduleIDList,
                                File moduleArchive,
                                File deploymentPlan)
                                  throws UnsupportedOperationException,
                                         IllegalStateException

      (optional) The redeploy method provides a means for updating currently deployed Java EE applications. This is an optional method for vendor implementation. Redeploy replaces a currently deployed application with an updated version. The runtime configuration information for the updated application must remain identical to the application it is updating. When an application update is redeployed, all existing client connections to the original running application must not be disrupted; new clients will connect to the application update. This operation is valid for TargetModuleIDs that represent a root module. A root TargetModuleID has no parent. A root TargetModuleID module and all its child modules will be redeployed. A child TargetModuleID module cannot be individually redeployed. The redeploy operation is complete only when this action for all the modules has completed.
      Parameters:
        `moduleIDList` - An array of designators of the applications to be updated.
        `moduleArchive` - The file name of the application archive to be disrtibuted.
        `deploymentPlan` - The deployment configuration information associated with this application archive.
      Returns:
        ProgressObject an object that tracks and reports the status of the redeploy operation.
      Throws:
        `IllegalStateException` - is thrown when the method is called when running in disconnected mode.
        `UnsupportedOperationException` - this optional command is not supported by this implementation.

    - #### redeploy

          ProgressObject redeploy(TargetModuleID[] moduleIDList,
                                InputStream moduleArchive,
                                InputStream deploymentPlan)
                                  throws UnsupportedOperationException,
                                         IllegalStateException

      (optional) The redeploy method provides a means for updating currently deployed Java EE applications. This is an optional method for vendor implementation. Redeploy replaces a currently deployed application with an updated version. The runtime configuration information for the updated application must remain identical to the application it is updating. When an application update is redeployed, all existing client connections to the original running application must not be disrupted; new clients will connect to the application update. This operation is valid for TargetModuleIDs that represent a root module. A root TargetModuleID has no parent. A root TargetModuleID module and all its child modules will be redeployed. A child TargetModuleID module cannot be individually redeployed. The redeploy operation is complete only when this action for all the modules has completed.
      Parameters:
        `moduleIDList` - An array of designators of the applications to be updated.
        `moduleArchive` - The input stream containing the application archive to be disrtibuted.
        `deploymentPlan` - The input stream containing the runtime configuration information associated with this application archive.
      Returns:
        ProgressObject an object that tracks and reports the status of the redeploy operation.
      Throws:
        `IllegalStateException` - is thrown when the method is called when running in disconnected mode.
        `UnsupportedOperationException` - this optional command is not supported by this implementation.

    - #### release

          void release()

      The release method is the mechanism by which the tool signals to the DeploymentManager that the tool does not need it to continue running connected to the platform. The tool may be signaling it wants to run in a disconnected mode or it is planning to shutdown. When release is called the DeploymentManager may close any Java EE resource connections it had for deployment configuration and perform other related resource cleanup. It should not accept any new operation requests (i.e., distribute, start stop, undeploy, redeploy. It should finish any operations that are currently in process. Each ProgressObject associated with a running operation should be marked as released (see the ProgressObject).

    - #### getDefaultLocale

          Locale getDefaultLocale()

      Returns the default locale supported by this implementation of javax.enterprise.deploy.spi subpackages.
      Returns:
        Locale the default locale for this implementation.

    - #### getCurrentLocale

          Locale getCurrentLocale()

      Returns the active locale this implementation of javax.enterprise.deploy.spi subpackages is running.
      Returns:
        Locale the active locale of this implementation.

    - #### setLocale

          void setLocale(Locale locale)
                         throws UnsupportedOperationException

      Set the active locale for this implementation of javax.enterprise.deploy.spi subpackages to run.
      Throws:
        `UnsupportedOperationException` - the provide locale is not supported.

    - #### getSupportedLocales

          Locale[] getSupportedLocales()

      Returns an array of supported locales for this implementation.
      Returns:
        Locale[] the list of supported locales.

    - #### isLocaleSupported

          boolean isLocaleSupported(Locale locale)

      Reports if this implementation supports the designated locale.
      Returns:
        A value of 'true' means it is support and 'false' it is not.

    - #### getDConfigBeanVersion

          DConfigBeanVersionType getDConfigBeanVersion()

      Returns the Java EE platform version number for which the configuration beans are provided. The beans must have been compiled with the J2SE version required by the Java EE platform.
      Returns:
        a DConfigBeanVersionType object representing the platform version number for which these beans are provided.

    - #### isDConfigBeanVersionSupported

          boolean isDConfigBeanVersionSupported(DConfigBeanVersionType version)

      Returns 'true' if the configuration beans support the Java EE platform version specified. It returns 'false' if the version is not supported.
      Parameters:
        `version` - a DConfigBeanVersionType object representing the Java EE platform version for which support is requested.
      Returns:
        'true' if the version is supported and 'false if not.

    - #### setDConfigBeanVersion

          void setDConfigBeanVersion(DConfigBeanVersionType version)
                                     throws DConfigBeanVersionUnsupportedException

      Set the configuration beans to be used to the Java EE platform version specificed.
      Parameters:
        `version` - a DConfigBeanVersionType object representing the Java EE platform version for which support is requested.
      Throws:
        `DConfigBeanVersionUnsupportedException` - when the requested bean version is not supported.

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.